/*
 * AlignmentStationary.cs
 * 
 * Gocator 2000/2300 C# Sample
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 *
 * Purpose: Connect to Gocator system and perform stationary alignment to a flat surface
 *
 */				

using System;
using System.Runtime.InteropServices;

static class Constants
{
    public const string SENSOR_IP = "192.168.1.10"; // IP of the sensor used for sensor connection GoSystem_FindSensorByIpAddress() call.
#if DEBUG
    public const string GODLLPATH = @"GoSdk.dll";
    public const string KAPIDLLPATH = @"kApi.dll";
#else
    public const string GODLLPATH = @"GoSdk.dll";
    public const string KAPIDLLPATH = @"kApi.dll";
#endif
}

namespace AlignmentStationary
{
    public delegate void onDataType(IntPtr ctx, IntPtr sys, IntPtr data);

    class AlignmentStationary
    {
        enum kStatus
        {
            kERROR_STATE = -1000,                                                // Invalid state.
            kERROR_NOT_FOUND = -999,                                             // Item is not found.
            kERROR_COMMAND = -998,                                               // Command not recognized.
            kERROR_PARAMETER = -997,                                             // Parameter is invalid.
            kERROR_UNIMPLEMENTED = -996,                                         // Feature not implemented.
            kERROR_HANDLE = -995,                                                // Handle is invalid.
            kERROR_MEMORY = -994,                                                // Out of memory.
            kERROR_TIMEOUT = -993,                                               // Action timed out.
            kERROR_INCOMPLETE = -992,                                            // Buffer not large enough for data.
            kERROR_STREAM = -991,                                                // Error in stream.
            kERROR_CLOSED = -990,                                                // Resource is no longer avaiable. 
            kERROR_VERSION = -989,                                               // Invalid version number.
            kERROR_ABORT = -988,                                                 // Operation aborted.
            kERROR_ALREADY_EXISTS = -987,                                        // Conflicts with existing item.
            kERROR_NETWORK = -986,                                               // Network setup/resource error.
            kERROR_HEAP = -985,                                                  // Heap error (leak/double-free).
            kERROR_FORMAT = -984,                                                // Data parsing/formatting error. 
            kERROR_READ_ONLY = -983,                                             // Object is read-only (cannot be written).
            kERROR_WRITE_ONLY = -982,                                            // Object is write-only (cannot be read). 
            kERROR_BUSY = -981,                                                  // Agent is busy (cannot service request).
            kERROR_CONFLICT = -980,                                              // State conflicts with another object.
            kERROR_OS = -979,                                                    // Generic error reported by underlying OS.
            kERROR_DEVICE = -978,                                                // Hardware device error.
            kERROR_FULL = -977,                                                  // Resource is already fully utilized.
            kERROR_IN_PROGRESS = -976,                                           // Operation is in progress, but not yet complete.
            kERROR = 0,                                                          // General error. 
            kOK = 1                                                              // Operation successful. 
        }

        enum GoAlignmentType
        {
            GO_ALIGNMENT_TYPE_STATIONARY = 0,
            GO_ALIGNMENT_TYPE_MOVING = 1
        }

        enum GoAlignmentTarget
        {
            GO_ALIGNMENT_TARGET_NONE = 0,                                       // No calibration target.
            GO_ALIGNMENT_TARGET_DISK = 1,                                       // Calibration disk.
            GO_ALIGNMENT_TARGET_BAR = 2,                                        // Calibration bar.
            GO_ALIGNMENT_TARGET_PLATE = 3                                      // Calibration plate.
        }

        enum GoDataMessageTypes
        {
            GO_DATA_MESSAGE_TYPE_UNKNOWN = -1,
            GO_DATA_MESSAGE_TYPE_STAMP = 0,
            GO_DATA_MESSAGE_TYPE_HEALTH = 1,
            GO_DATA_MESSAGE_TYPE_VIDEO = 2,
            GO_DATA_MESSAGE_TYPE_RANGE = 3,
            GO_DATA_MESSAGE_TYPE_RANGE_INTENSITY = 4,
            GO_DATA_MESSAGE_TYPE_PROFILE = 5,
            GO_DATA_MESSAGE_TYPE_PROFILE_INTENSITY = 6,
            GO_DATA_MESSAGE_TYPE_RESAMPLED_PROFILE = 7,
            GO_DATA_MESSAGE_TYPE_SURFACE = 8,
            GO_DATA_MESSAGE_TYPE_SURFACE_INTENSITY = 9,
            GO_DATA_MESSAGE_TYPE_MEASUREMENT = 10,
            GO_DATA_MESSAGE_TYPE_ALIGNMENT = 11,
            GO_DATA_MESSAGE_TYPE_EXPOSURE_CAL = 12
        }

        public struct address
        {
            public Int32 version;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 16)]
            public byte[] IPaddress;
        }

        // use DLL import to access GoSdkd.dll/GoSdk.dll and kApid.dll/kApi.dll
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSdk_Construct(ref IntPtr assembly);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_Construct(ref IntPtr system, IntPtr allocator);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_FindSensorByIpAddress(IntPtr system, IntPtr addr, ref IntPtr sensor);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_EnableData(IntPtr system, bool enable);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSensor_Connect(IntPtr sensor);
        [DllImport(Constants.GODLLPATH)]
        private static extern IntPtr GoSensor_Setup(IntPtr sensor);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSetup_SetAlignmentType(IntPtr setup, GoAlignmentType Type);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSetup_SetAlignmentStationaryTarget(IntPtr setup, GoAlignmentTarget target);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSensor_Align(IntPtr sensor);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_ReceiveData(IntPtr system, ref IntPtr data, UInt64 timeout);
        [DllImport(Constants.GODLLPATH)]
        private static extern UInt32 GoDataSet_Count(IntPtr dataset);
        [DllImport(Constants.GODLLPATH)]
        private static extern IntPtr GoDataSet_At(IntPtr dataset, UInt32 index);
        [DllImport(Constants.GODLLPATH)]
        private static extern bool kObject_Is(IntPtr obj, IntPtr kType);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoAlignMsg_Status(IntPtr msg);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_Start(IntPtr system);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoSystem_Stop(IntPtr system);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoDataMsg_Type(IntPtr msg);
        [DllImport(Constants.GODLLPATH)]
        private static extern Int32 GoDestroy(IntPtr obj);
        [DllImport(Constants.KAPIDLLPATH)]
        private static extern Int32 kIpAddress_Parse(IntPtr addrPtr, [MarshalAs(UnmanagedType.LPStr)] string text);

        static int Main(string[] args)
        {
            kStatus status;
            IntPtr api = IntPtr.Zero;
            IntPtr system = IntPtr.Zero;
            IntPtr sensor = IntPtr.Zero;
            IntPtr setup = IntPtr.Zero;
            IntPtr dataset = IntPtr.Zero;
            IntPtr alignMsg = IntPtr.Zero;
            IntPtr addrPtr = IntPtr.Zero;
            address addr = new address();

            if ((status = (kStatus)GoSdk_Construct(ref api)) != kStatus.kOK)
            {
                Console.WriteLine("GoSdk_Construct Error:{0}", (int)status);
                return (int) status;
            }

            if ((status = (kStatus)GoSystem_Construct(ref system, IntPtr.Zero)) != kStatus.kOK)
            {
                Console.WriteLine("GoSystem_Construct Error:{0}", (int)status);
                return (int) status;
            }

            addrPtr = Marshal.AllocHGlobal(Marshal.SizeOf(addr));
            Marshal.StructureToPtr(addr, addrPtr, false);

            if ((status = (kStatus)kIpAddress_Parse(addrPtr, Constants.SENSOR_IP)) != kStatus.kOK)
            {
                Console.WriteLine("kIpAddress_Parse Error:{0}", (int)status);
                return (int)status;
            }

            if ((status = (kStatus)GoSystem_FindSensorByIpAddress(system, addrPtr, ref sensor)) != kStatus.kOK)
            {
                Console.WriteLine("GoSystem_FindSensorByIpAddress Error:{0}", (int)status);
                return (int)status;
            }

            if ((status = (kStatus)GoSensor_Connect(sensor)) != kStatus.kOK)
            {
                Console.WriteLine("GoSensor_Connect Error:{0}", (int)status);
                return (int) status;
            }

            if ((status = (kStatus)GoSystem_EnableData(system, true)) != kStatus.kOK)
            {
                Console.WriteLine("GoSystem_EnableData Error:{0}", (int)status);
                return (int) status;
            }

            if ((setup = GoSensor_Setup(sensor)) == IntPtr.Zero)
            {
                Console.WriteLine("GoSensor_Setup: Invalid Handle");
                return 0;
            }

            if ((status = (kStatus)GoSetup_SetAlignmentType(setup, GoAlignmentType.GO_ALIGNMENT_TYPE_STATIONARY)) != kStatus.kOK)
            {
                Console.WriteLine("GoSetup_SetAlignmentType Error:{0}", (int)status);
                return (int) status;
            }

            if ((status = (kStatus)GoSetup_SetAlignmentStationaryTarget(setup, GoAlignmentTarget.GO_ALIGNMENT_TARGET_NONE)) != kStatus.kOK)
            {
                Console.WriteLine("GoSetup_SetAlignmentStationaryTarget Error:{0}", (int)status);
                return (int) status;
            }

            if ((status = (kStatus)GoSensor_Align(sensor)) != kStatus.kOK)
            {
                Console.WriteLine("GoSensor_Align Error:{0}", (int)status);
                return (int)status;
            }

            Console.WriteLine("Waiting for alignment calibration data to be collected...");

            status = (kStatus)GoSystem_ReceiveData(system, ref dataset, 30000000);

            if (status == kStatus.kERROR_TIMEOUT)
            {
                Console.WriteLine("Failed to collect data for calibration within timeout limit...");
            }
            else if (status != kStatus.kOK)
            {
                Console.WriteLine("GoSystem_ReceiveData Error:{0}", (int)status);
            }
            else
            {
                //each result can have multiple data items
                uint itemCount;
                itemCount = GoDataSet_Count(dataset);
                //each result can have multiple data items
                for (UInt32 i = 0; i < itemCount; i++)
                {
                    IntPtr dataItem = GoDataSet_At(dataset, i);
                    // if data item is of type GO_DATA_MESSAGE_TYPE_ALIGNMENT
                    if (GoDataMsg_Type(dataItem) == (Int32)GoDataMessageTypes.GO_DATA_MESSAGE_TYPE_ALIGNMENT)
                    {
                        if ((status = (kStatus)GoAlignMsg_Status(dataItem)) == kStatus.kOK)
                        {
                            Console.WriteLine("Alignment calibration successful!", status);
                        }
                        else
                        {
                            Console.WriteLine("Alignment calibration failed.", status);
                        }
                    }
                }
            }

            if ((status = (kStatus)GoDestroy(dataset)) != kStatus.kOK)
            {
                Console.Write("GoDestroy Error:{0}", (int)status);
                return (int) status;
            }

            if ((status = (kStatus)GoSystem_Stop(system)) != kStatus.kOK)
            {
                Console.Write("GoSystem_Stop Error:{0}", (int)status);
                return (int) status;
            }

            // destroy handles
            GoDestroy(system);
            GoDestroy(api);


            // wait for Enter key
            Console.WriteLine("\nPress ENTER to continue");
            do
            {
                System.Threading.Thread.Sleep(100);

            } while (Console.Read() != (int)ConsoleKey.Enter);
            return (int) kStatus.kOK;
        }
    }
}